unit UConsulta;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, StdCtrls, Buttons, DB, DBClient, DBCtrls, Grids,
  //FileCtrl,
  DBGrids, MidasLib, Mask,
  ShellAPI, pngimage;

const
  //ALERTAS
  ERRO_SRV    = 'Erro inicializando servidor.';
  START_SRV   = 'Servidor inicializado com sucesso.';
  STOP_SRV    = 'Servidor interrompido.';

type TIPV4 = record
  d,c,b,a: byte;
end;

type stAddress = record
  Ip: string;
  Socket: Word;
end;

type
  TTABSOCK = record
    TabSock: array[0..1023] of integer;
    TabIP: array[0..1023] of DWORD;
    NumSockConec: integer;
end;

type
  TFConsulta = class(TForm)
    TabMensagens: TTabSheet;
    TabProdutos: TTabSheet;
    Panel1: TPanel;
    TabMonitora: TTabSheet;
    BtnMonitora: TBitBtn;
    BtnMensagens: TBitBtn;
    PC: TPageControl;
    BtnProdutos: TBitBtn;
    DSProdutos: TDataSource;
    Image1: TImage;
    ListTerms: TListBox;
    Timer100ms: TTimer;
    Timer3Seg: TTimer;
    TxtConectados: TStaticText;
    CDSProdutos: TClientDataSet;
    CDSProdutosBarCode: TStringField;
    CDSProdutosProduto: TStringField;
    CDSProdutosPreco: TCurrencyField;
    GridProdutos: TDBGrid;
    DBNavigator1: TDBNavigator;
    StaticText2: TStaticText;
    MemoRecv: TMemo;
    BtnIniciar: TBitBtn;
    BtnLimparMemo: TButton;
    EdtPesquisar: TEdit;
    BtnPesquisar: TBitBtn;
    GrpIMsg: TGroupBox;
    LabLine1: TLabel;
    LabLine2: TLabel;
    LabTimeEx: TLabel;
    EdtLine1: TEdit;
    EdtLine2: TEdit;
    EdtTimeEx: TEdit;
    BtnMsgSend: TButton;
    procedure BtnMonitoraClick(Sender: TObject);
    procedure BtnMensagensClick(Sender: TObject);
    procedure BtnProdutosClick(Sender: TObject);
    procedure BtnIniciarClick(Sender: TObject);
    procedure BtnLimparMemoClick(Sender: TObject);
    procedure BtnPesquisarClick(Sender: TObject);
    procedure BtnMsgSendClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListTermsClick(Sender: TObject);
    procedure Timer100msTimer(Sender: TObject);
    procedure Timer3SegTimer(Sender: TObject);

  private
    { Private declarations }

  public
    { Public declarations }
    TabTerms: TTABSOCK;

  end;
var
  FConsulta: TFConsulta;
  SelTerm: integer;

implementation

{$R *.dfm}

//------------------------------------------------------------------------------
function  GetTabConectados(nada: Integer): TTABSOCK; stdcall; far; external 'VP.dll';
function Inet_NtoA(nIP: DWORD): PChar ; far; stdcall; external 'VP.dll';
procedure vInitialize; stdcall; far; external 'VP.dll';
function tc_startserver: Integer; stdcall; far; external 'VP.dll';
function dll_version: DWORD; stdcall; far; external 'VP.dll';
function bTerminate: Boolean; far; stdcall; external 'VP.dll';
function bSendDisplayMsg(ID: Integer; Linha1: PChar; Linha2: Pchar; Tempo: Integer): Boolean; stdcall; far; external 'VP.dll';
function bSendProdNotFound(ID: Integer): Boolean; stdcall; far; external 'VP.dll';
function bSendProdPrice(ID: Integer; var NameProd: PChar; var PriceProd : PChar): Boolean; stdcall; far; external 'VP.dll';
function bReceiveBarcode(var stAddress; var BarCode: PChar): Boolean; stdcall; far; external 'VP.dll';
//------------------------------------------------------------------------------

procedure TFConsulta.BtnIniciarClick(Sender: TObject);
begin
  if (BtnIniciar.Caption = 'Parar') then
  begin
    if (bTerminate = true) then
    begin
      MemoRecv.Lines.Add(STOP_SRV);
      Timer3seg.Enabled := false;
      Timer100ms.Enabled := false;
      BtnIniciar.Caption := 'Iniciar';
      BtnMonitora.Font.Color := clRed;
      BtnMensagens.Enabled := False;
    end else begin
      MemoRecv.Lines.Add(ERRO_SRV);
      ShowMessage(ERRO_SRV);
    end;
  end else begin
    if (tc_startserver <> 0) then begin
      MemoRecv.Lines.Add(START_SRV);
      BtnIniciar.Caption := 'Parar';
      BtnMonitora.Font.Color := clGreen;
      BtnMensagens.Enabled := True;
      ListTerms.Clear;
      Timer3seg.Enabled := true;
      Timer100ms.Enabled := true;
    end else begin
      MemoRecv.Lines.Add(ERRO_SRV);
      Timer3seg.Enabled := false;
      Timer100ms.Enabled := false;
      ShowMessage(ERRO_SRV);
    end;
  end;
end;

procedure TFConsulta.BtnLimparMemoClick(Sender: TObject);
begin
  MemoRecv.Clear;
end;

procedure TFConsulta.BtnMensagensClick(Sender: TObject);
begin
  FConsulta.PC.ActivePageIndex := 1;
end;

procedure TFConsulta.BtnMonitoraClick(Sender: TObject);
begin
  FConsulta.PC.ActivePageIndex := 0;
end;

procedure TFConsulta.BtnMsgSendClick(Sender: TObject);
var
  Lin1: Pchar;
  Lin2: PChar;
  Selected: String;
  Position: Integer;
  ID: stAddress;
begin
  Lin1:= Pchar(EdtLine1.Text);
  Lin2:= Pchar(EdtLine2.Text);
  if (ListTerms.ItemIndex < 0) then
  begin
    ShowMessage('Selecione um Terminal');
  end else begin
    Selected := ListTerms.Items.Strings[ListTerms.ItemIndex];
    Position := LastDelimiter(':', Selected);
    ID.Ip:= Copy(Selected,1,Position - 1);
    ID.Socket:= StrToInt(Copy(Selected,Position+1,Length(Selected) - Position));
    bSendDisplayMsg(ID.Socket,
                  Lin1,
                  Lin2,
                  StrToInt(EdtTimeEx.Text)
                  );
    MemoRecv.Lines.Add(ID.Ip + ':' + IntToStr(ID.Socket) + ' -> ' +
      'Mensagem enviada ao Terminal');
  end;
end;

procedure TFConsulta.BtnPesquisarClick(Sender: TObject);
begin
  if (EdtPesquisar.Text = '') then
  begin
    ShowMessage('Por favor, entre com o Cdigo do produto.');
  end else begin
    if (CDSProdutos.Locate('BarCode', Trim(EdtPesquisar.Text), [])) then
    begin
      ShowMessage('Produto: ' + CDSProdutos.FieldByName('Produto').AsString);
    end else begin
      ShowMessage('Cdigo do produto no consta na Base de Dados.');
    end;
  end;
end;

procedure TFConsulta.BtnProdutosClick(Sender: TObject);
begin
  FConsulta.PC.ActivePageIndex := 2;
end;

procedure TFConsulta.FormCreate(Sender: TObject);
begin
  SelTerm:= -1;
  FConsulta.PC.ActivePageIndex := 0;
  vInitialize;
  MemoRecv.Lines.Add('Verso da DLL: ' +
  copy(IntToHex(dll_version,8),1,2) + '.' +
  copy(IntToHex(dll_version,8),3,2) + '.' +
  copy(IntToHex(dll_version,8),5,2) + '.' +
  copy(IntToHex(dll_version,8),7,2) );
  BtnMonitora.Font.Color := clRed;
  BtnMensagens.Enabled := False;
  CDSProdutos.FileName:= ExtractFilePath(Application.ExeName) + '\DBProdutos.xml';
  GridProdutos.Columns[0].Width := 120;
  GridProdutos.Columns[1].Width := 225;
  GridProdutos.Columns[2].Width := 85;
  CDSProdutos.Active := true;
  DSProdutos.Enabled := true;
  //BtnIniciar.Click;   //iniciando o servio no statup
end;

procedure TFConsulta.ListTermsClick(Sender: TObject);
var
  i : integer;
begin
  with (Sender as TListBox) do begin
    i := ItemIndex-1;
    repeat
      inc(i);
      SelTerm := TabTerms.TabSock[i];
    until (TabTerms.TabSock[i]<>0) or (i>1023);
  end;
end;

procedure TFConsulta.Timer100msTimer(Sender: TObject);
var
  stBarCode: stAddress;
  BarCode: PChar;
  produto: PChar;
  preco: PChar;
begin
  if ( bReceiveBarcode(stBarCode, BarCode) )  then
  begin
    if (CDSProdutos.Locate('BarCode',String(BarCode),[])) then
    begin
     produto := PChar(CDSProdutos.FieldByName('Produto').AsString);
     preco := PChar(CDSProdutos.FieldByName('Preco').AsString);
     bSendProdPrice(stBarCode.Socket, produto , preco);
     MemoRecv.Lines.Add(stBarCode.Ip + ':' + IntToStr(stBarCode.Socket) + ' -> ' +
      String(Barcode) + '|' + String(Produto) + '|' + String(Preco));
    end else begin
      //produto := PChar('PRODUTO  NAO');
      //preco := PChar('ENCONTRADO');
      //bSendProdPrice(stBarCode.Socket, produto , preco);  //enviando msg manualmente
      bSendProdNotFound(stBarCode.Socket);                  //utilizando funo do verificador
      MemoRecv.Lines.Add(stBarCode.Ip + ':' + IntToStr(stBarCode.Socket) + ' -> ' +
          String(Barcode) + '|' + 'PRODUTO NAO ENCONTRADO');
    end;
  end;
end;

procedure TFConsulta.Timer3SegTimer(Sender: TObject);
var
  i: integer;
  sIP: PChar;
  SelTermBkp: integer;
  IdxLista: integer;

begin
  SelTermBkp:= -1;
  TabTerms := GetTabConectados(1);
  ListTerms.Clear;
  IdxLista := 0;
  for i:= 0 to TabTerms.NumSockConec-1 do
  begin
    if TabTerms.TabIP[i] <> 0 then
    begin
      sIP:= Inet_NtoA(TabTerms.TabIP[i]);
      if ((TabTerms.TabSock[i] = SelTerm) and (SelTermBkp = -1)) then
      begin
        SelTermBkp := IdxLista;
      end;
      inc(IdxLista);
      ListTerms.Items.Add(String(sIP) + ':' + IntToStr(TabTerms.TabSock[i]));
    end;
  end;
  ListTerms.ItemIndex := SelTermBkp;
  if (SelTermBkp = -1) then SelTerm := 0;
end;

end.
